#include <system.h>

// KBDUS stands for US keyboard layout. 
// Create a layout in a different language if you want
// or confuse your friends with a weired mapping :-)
unsigned char kbdus[128] =
{
    0,  27, '1', '2', '3', '4', '5', '6', '7', '8',	/* 9 */
  '9', '0', '-', '=', '\b',	/* Backspace */
  '\t',			/* Tab */
  'q', 'w', 'e', 'r',	/* 19 */
  't', 'y', 'u', 'i', 'o', 'p', '[', ']', '\n',		/* Enter key */
    0,			/* 29   - Control */
  'a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l', ';',	/* 39 */
 '\'', '`',   0,		/* Left shift */
 '\\', 'z', 'x', 'c', 'v', 'b', 'n',			/* 49 */
  'm', ',', '.', '/',   0,					/* Right shift */
  '*',
    0,	/* Alt */
  ' ',	/* Space bar */
    0,	/* Caps lock */
    0,	/* 59 - F1 key ... > */
    0,   0,   0,   0,   0,   0,   0,   0,
    0,	/* < ... F10 */
    0,	/* 69 - Num lock*/
    0,	/* Scroll Lock */
    0,	/* Home key */
    0,	/* Up Arrow */
    0,	/* Page Up */
  '-',
    0,	/* Left Arrow */
    0,
    0,	/* Right Arrow */
  '+',
    0,	/* 79 - End key*/
    0,	/* Down Arrow */
    0,	/* Page Down */
    0,	/* Insert Key */
    0,	/* Delete Key */
    0,   0,   0,
    0,	/* F11 Key */
    0,	/* F12 Key */
    0,	/* All other keys are undefined */
};

// Handler for keyboard interrupts
// We can register this one with "irq_install_handler".
void keyboard_handler(struct regs *r)
{
    unsigned char scancode;

    // Read from the keyboards data buffer
    scancode = inportb(0x60);

    // Check if the key has been released
    if (scancode & 0x80)
    {
		// Use this branch to check if shift, alt, control, ... has been released
    }
    else
    {
		// Here a key is pressed. When you keep holding the key
		// down you will receive interrupts repeatedly.

		// Here we will output each char that we receive.
        putch(kbdus[scancode]);
    }
}

// Install the keyboard interrupt request handler
void keyboard_install()
{
    irq_install_handler(1, keyboard_handler);
}