#include <system.h>

// copy count bytes from src to dest
void *memcpy(void *dest, const void *src, size_t count)
{
    const char *sp = (const char *)src;
    char *dp = (char *)dest;
    for(; count != 0; count--) *dp++ = *sp++;
    return dest;
}

// set count bytes in dest to val
void *memset(void *dest, char val, size_t count)
{
    char *temp = (char *)dest;
    for( ; count != 0; count--) *temp++ = val;
    return dest;
}

// Same as above, but this time, we're working with a 16-bit 'val' and dest pointer.
unsigned short *memsetw(unsigned short *dest, unsigned short val, size_t count)
{
    unsigned short *temp = (unsigned short *)dest;
    for( ; count != 0; count--) *temp++ = val;
    return dest;
}

// Returns the length of a character array.
size_t strlen(const char *str)
{
    size_t retval;
    for(retval = 0; *str != '\0'; str++) retval++;
    return retval;
}

// Reading from IO ports
unsigned char inportb (unsigned short _port)
{
    unsigned char rv;
    __asm__ __volatile__ ("inb %1, %0" : "=a" (rv) : "dN" (_port));
    return rv;
}

// Writing to IO ports
void outportb (unsigned short _port, unsigned char _data)
{
    __asm__ __volatile__ ("outb %1, %0" : : "dN" (_port), "a" (_data));
}

// The main function loops for eternity. This is to keep our OS alive.
int main()
{
    /* You would add commands after here */
	gdt_install();
	init_video();
	puts("-------------------------------------------------------------------\n");
	puts("------------------         JofreOS         ------------------------\n");
	puts("-------------------------------------------------------------------\n");
	puts("\n\n\n");
	puts("Woho success, I can put out strings in my own Operating System!\n");
	idt_install();
	puts("\nInterrupt Descriptor table has successfully been installed!\n");
	isrs_install();
	puts("\nInterrupt Service Routines registered! Exceptions enabled!\n");
	//putch(10 / 0);
    irq_install();
	keyboard_install();
	timer_install();
    __asm__ __volatile__ ("sti");
	//beep();
	putfs("Hello %s","asd");
	long asd = 123;
	putfs("You are using %s in version %i.","JofreOS",1);
    for (;;);
	return(0);
}